Index: code/trunk/src/orxonox/controllers/FormationController.h
===================================================================
--- code/trunk/src/orxonox/controllers/FormationController.h	(revision 9016)
+++ code/trunk/src/orxonox/controllers/FormationController.h	(revision 9016)
@@ -0,0 +1,177 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _FormationController_h__
+#define _FormationController_h__
+
+#include "OrxonoxPrereqs.h"
+
+#include <vector>
+#include "core/Super.h"
+
+#include "util/Math.h"
+#include "core/OrxonoxClass.h"
+#include "controllers/Controller.h"
+#include "worldentities/ControllableEntity.h"
+
+
+namespace orxonox {
+
+  class _OrxonoxExport FormationController : public Controller
+  {
+
+      public:
+      FormationController(BaseObject* creator);
+
+      virtual ~FormationController();
+
+      virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode);
+
+
+      static void formationflight(const bool form);
+      static void masteraction(const int action);
+      static void followme();
+      static void passivebehaviour(const bool passive);
+      static void formationsize(const int size);
+
+      inline void setFormationFlight(bool formation)
+           { this->formationFlight_ = formation; }
+      inline bool getFormationFlight() const
+           { return this->formationFlight_; }
+
+      inline void setFormationSize(int size)
+           { this->maxFormationSize_ = size; }
+      inline int getFormationSize() const
+           { return this->maxFormationSize_; }
+
+
+      inline void setPassive(bool passive)
+           { this->passive_ = passive; }
+      inline bool getPassive() const
+           { return this->passive_; }
+
+      inline void setTeam(int team)
+           { this->team_ = team; }
+      inline int getTeam() const
+           { return this->team_; }
+
+      /**
+        @brief Mode of the formation, behaviour of slaves
+               Normal-normal behaviour
+               Defend-just defend the master
+               Attack-leave formation, attack every target
+      */
+      enum FormationMode {NORMAL,DEFEND,ATTACK};
+
+      /**
+        @brief Sets the new mode. If master, set it for all slaves.
+      */
+      void setFormationMode(FormationMode val);
+      inline FormationMode getFormationMode() const
+           { return this->formationMode_; }
+
+    protected:
+      bool formationFlight_;
+      bool passive_;
+      int team_;
+      unsigned int maxFormationSize_;
+      int freedomCount_;
+      enum State {SLAVE, MASTER, FREE};
+
+      State state_;
+      std::vector<FormationController*> slaves_;
+      FormationController* myMaster_;
+
+      FormationMode formationMode_;
+
+      enum SpecificMasterAction {NONE, HOLD, SPIN, TURN180, FOLLOW};
+      SpecificMasterAction specificMasterAction_;
+      int specificMasterActionHoldCount_;
+      float speedCounter_; //for speed adjustment when following
+
+      void moveToPosition(const Vector3& target);
+      void moveToTargetPosition();
+      void absoluteMoveToPosition(const Vector3& target);
+      void copyOrientation(const Quaternion& orient);
+      void copyTargetOrientation();
+
+      void removeFromFormation();
+      void unregisterSlave();
+      void searchNewMaster();
+      void commandSlaves();
+      void setNewMasterWithinFormation();
+
+      void freeSlaves();
+      void forceFreeSlaves();
+      void loseMasterState();
+      void forceFreedom();
+      bool forcedFree();
+
+      void takeLeadOfFormation();
+      void masterAttacked(Pawn* originator);
+
+      void specificMasterActionHold();
+      void turn180Init();
+      void spinInit();
+      void spin();
+      void turn180();
+      void followInit(Pawn* pawn, const bool always = false, const int secondsToFollow = 100);
+      void followRandomHumanInit();
+      void follow();
+
+      void setTargetPosition(const Vector3& target);
+      void searchRandomTargetPosition();
+
+      void setTargetOrientation(const Quaternion& orient);
+      void setTargetOrientation(Pawn* target);
+
+      virtual void positionReached() {}
+
+      static bool sameTeam(ControllableEntity* entity1, ControllableEntity* entity2, Gametype* gametype); // hack
+
+
+      void setTarget(Pawn* target);
+      void searchNewTarget();
+      void forgetTarget();
+
+      void targetDied();
+
+      bool bHasTargetPosition_;
+      Vector3 targetPosition_;
+      bool bHasTargetOrientation_;
+      Quaternion targetOrientation_;
+
+      WeakPtr<Pawn> target_;
+      bool bShooting_;
+  };
+
+
+}
+#endif /* _FormationController_h__ */
+
+
Index: code/trunk/src/orxonox/controllers/HumanController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/HumanController.cc	(revision 8952)
+++ code/trunk/src/orxonox/controllers/HumanController.cc	(revision 9016)
@@ -50,4 +50,6 @@
     SetConsoleCommand("HumanController", "rotatePitch",            &HumanController::rotatePitch   ).addShortcut().setAsInputCommand();
     SetConsoleCommand("HumanController", "rotateRoll",             &HumanController::rotateRoll    ).addShortcut().setAsInputCommand();
+    SetConsoleCommand("HumanController", "toggleFormationFlight",  &HumanController::toggleFormationFlight).addShortcut().keybindMode(KeybindMode::OnPress);
+    SetConsoleCommand("HumanController", "FFChangeMode",  &HumanController::FFChangeMode).addShortcut().keybindMode(KeybindMode::OnPress);
     SetConsoleCommand("HumanController", __CC_fire_name,           &HumanController::fire          ).addShortcut().keybindMode(KeybindMode::OnHold);
     SetConsoleCommand("HumanController", "reload",                 &HumanController::reload        ).addShortcut();
@@ -69,5 +71,5 @@
     /*static*/ const float HumanController::BOOSTING_TIME = 0.1f;
 
-    HumanController::HumanController(BaseObject* creator) : Controller(creator)
+    HumanController::HumanController(BaseObject* creator) : FormationController(creator)
     {
         RegisterObject(HumanController);
@@ -76,5 +78,4 @@
         this->boosting_ = false;
         this->boosting_ = false;
-
         HumanController::localController_s = this;
         this->boostingTimeout_.setTimer(HumanController::BOOSTING_TIME, false, createExecutor(createFunctor(&HumanController::terminateBoosting, this)));
@@ -84,4 +85,8 @@
     HumanController::~HumanController()
     {
+        if (HumanController::localController_s) 
+        {
+            HumanController::localController_s->removeFromFormation();
+        }
         HumanController::localController_s = 0;
     }
@@ -95,4 +100,11 @@
                 orxout(internal_warning) << "HumanController, Warning: Using a ControllableEntity without Camera" << endl;
         }
+
+        // commandslaves when Master of a formation
+        if (HumanController::localController_s && HumanController::localController_s->state_==MASTER)
+        {
+            if (HumanController::localController_s->formationMode_ != ATTACK)
+                HumanController::localController_s->commandSlaves();
+        }
     }
 
@@ -160,5 +172,12 @@
     {
         if (HumanController::localController_s && HumanController::localController_s->controllableEntity_)
+        {
             HumanController::localController_s->controllableEntity_->fire(firemode);
+            //if human fires, set slaves free. See FormationController::forceFreeSlaves()
+            if (HumanController::localController_s->state_==MASTER && HumanController::localController_s->formationMode_ == NORMAL)
+            {
+                HumanController::localController_s->forceFreeSlaves();
+            }
+        }
     }
 
@@ -195,6 +214,6 @@
             this->boosting_ = true;
             this->boostingTimeout_.startTimer();
-            
-            this->controllableEntity_->boost(this->boosting_);
+            if(this->controllableEntity_)
+                this->controllableEntity_->boost(this->boosting_);
 //            orxout() << "Start boosting" << endl;
         }
@@ -209,6 +228,6 @@
         this->boosting_ = false;
         this->boostingTimeout_.stopTimer();
-
-        this->controllableEntity_->boost(this->boosting_);
+        if(this->controllableEntity_)
+            this->controllableEntity_->boost(this->boosting_);
 //        orxout() << "Stop boosting" << endl;
     }
@@ -262,4 +281,63 @@
     }
 
+    /**
+    @brief
+       toggle the formation. Not usable, if formationflight is disabled generally (formationFlight_)
+    */
+    void HumanController::toggleFormationFlight()
+    {
+        if (HumanController::localController_s)
+        {
+            if (!HumanController::localController_s->formationFlight_)
+            {
+                return; //dont use when formationFlight is disabled
+            }
+            if (HumanController::localController_s->state_==MASTER)
+            {
+                HumanController::localController_s->loseMasterState();
+                orxout(message) <<"FormationFlight disabled "<< endl;
+            } else //SLAVE or FREE
+            {
+                HumanController::localController_s->takeLeadOfFormation();
+                orxout(message) <<"FormationFlight enabled "<< endl;
+            }
+            
+        }
+
+    }
+
+    /**
+    @brief
+       Switch through the different Modes of formationflight. You must be a master of a formation to use.
+    */
+    void HumanController::FFChangeMode()
+    {
+        if (HumanController::localController_s && HumanController::localController_s->state_==MASTER)
+        {
+            switch (HumanController::localController_s->getFormationMode()) {
+                case NORMAL:
+                    HumanController::localController_s->setFormationMode(DEFEND);
+                    orxout(message) <<"Mode: DEFEND "<< endl;
+                    break;
+                case DEFEND:
+                    HumanController::localController_s->setFormationMode(ATTACK);
+                    orxout(message) <<"Mode: ATTACK "<< endl;
+                    break;
+                case ATTACK:
+                    HumanController::localController_s->setFormationMode(NORMAL);
+                    orxout(message) <<"Mode: NORMAL "<< endl;
+                    break;
+            }
+        }
+    }
+
+
+    //used, when slaves are in DEFEND mode.
+    void HumanController::hit(Pawn* originator, btManifoldPoint& contactpoint, float damage)
+    {
+        if (!this->formationFlight_ || this->state_!=MASTER || this->formationMode_!=DEFEND) return;
+            this->masterAttacked(originator);
+    }
+
     void HumanController::addBots(unsigned int amount)
     {
Index: code/trunk/src/orxonox/controllers/HumanController.h
===================================================================
--- code/trunk/src/orxonox/controllers/HumanController.h	(revision 8952)
+++ code/trunk/src/orxonox/controllers/HumanController.h	(revision 9016)
@@ -34,5 +34,5 @@
 #include "tools/Timer.h"
 #include "tools/interfaces/Tickable.h"
-#include "Controller.h"
+#include "FormationController.h"
 
 // tolua_begin
@@ -41,5 +41,5 @@
     class _OrxonoxExport HumanController
 // tolua_end
-        : public Controller, public Tickable
+        : public FormationController, public Tickable
     { // tolua_export
         public:
@@ -74,5 +74,6 @@
             void keepBoosting(void);
             void terminateBoosting(void);
-            
+                  
+
             static void greet();
             static void switchCamera();
@@ -84,4 +85,9 @@
             static void toggleGodMode();
             static void myposition();
+
+            static void toggleFormationFlight();
+            static void FFChangeMode();
+            virtual void hit(Pawn* originator, btManifoldPoint& contactpoint, float damage);
+
 
             static void addBots(unsigned int amount);
Index: code/trunk/src/orxonox/controllers/NewHumanController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/NewHumanController.cc	(revision 8952)
+++ code/trunk/src/orxonox/controllers/NewHumanController.cc	(revision 9016)
@@ -291,10 +291,12 @@
         }
         else
-            HumanController::localController_s->getControllableEntity()->fire(firemode);
-
+            HumanController::doFire(firemode); //call for formationflight
     }
 
     void NewHumanController::hit(Pawn* originator, btManifoldPoint& contactpoint, float damage)
     {
+        //Used in HumanController for formationFlight
+        HumanController::hit(originator,contactpoint,damage);
+        
         if (this->showDamageOverlay_ && !this->controlPaused_ && this->controllableEntity_ && !this->controllableEntity_->isInMouseLook())
         {
Index: code/trunk/src/orxonox/controllers/NewHumanController.h
===================================================================
--- code/trunk/src/orxonox/controllers/NewHumanController.h	(revision 8952)
+++ code/trunk/src/orxonox/controllers/NewHumanController.h	(revision 9016)
@@ -69,4 +69,7 @@
             virtual void doResumeControl();
 
+            float getCurrentYaw(){ return this->currentYaw_; }
+            float getCurrentPitch(){ return this->currentPitch_; }
+
 
         protected:
Index: code/trunk/src/orxonox/controllers/WaypointPatrolController.cc
===================================================================
--- code/trunk/src/orxonox/controllers/WaypointPatrolController.cc	(revision 8952)
+++ code/trunk/src/orxonox/controllers/WaypointPatrolController.cc	(revision 9016)
@@ -42,5 +42,4 @@
         RegisterObject(WaypointPatrolController);
 
-        //this->team_ = 0;
         this->alertnessradius_ = 500;
 
@@ -53,5 +52,4 @@
 
         XMLPortParam(WaypointPatrolController, "alertnessradius", setAlertnessRadius, getAlertnessRadius, xmlelement, mode).defaultValues(500.0f);
-//        XMLPortParam(WaypointPatrolController, "team", setTeam, getTeam, xmlelement, mode).defaultValues(0);
     }
 
Index: code/trunk/src/orxonox/controllers/WaypointPatrolController.h
===================================================================
--- code/trunk/src/orxonox/controllers/WaypointPatrolController.h	(revision 8952)
+++ code/trunk/src/orxonox/controllers/WaypointPatrolController.h	(revision 9016)
@@ -46,9 +46,4 @@
             virtual void tick(float dt);
 
-           /* inline void setTeam(int team)
-                { this->team_ = team; }
-            inline int getTeam() const
-                { return this->team_; } */
-
             inline void setAlertnessRadius(float radius)
                 { this->alertnessradius_ = radius; }
@@ -59,5 +54,4 @@
             void searchEnemy();
 
-            //int team_;
             float alertnessradius_;
             Timer patrolTimer_;
Index: code/trunk/src/orxonox/gametypes/CMakeLists.txt
===================================================================
--- code/trunk/src/orxonox/gametypes/CMakeLists.txt	(revision 8952)
+++ code/trunk/src/orxonox/gametypes/CMakeLists.txt	(revision 9016)
@@ -9,3 +9,5 @@
   LastManStanding.cc
   LastTeamStanding.cc
+  TeamGametype.cc
+  Mission.cc
 )
Index: code/trunk/src/orxonox/gametypes/Gametype.cc
===================================================================
--- code/trunk/src/orxonox/gametypes/Gametype.cc	(revision 8952)
+++ code/trunk/src/orxonox/gametypes/Gametype.cc	(revision 9016)
@@ -123,5 +123,5 @@
         if (this->gtinfo_->isStartCountdownRunning() && !this->gtinfo_->hasStarted())
             this->gtinfo_->countdownStartCountdown(dt);
-
+			
         if (!this->gtinfo_->hasStarted())
         {
@@ -131,6 +131,7 @@
                 if(it->first->isHumanPlayer() && it->first->isReadyToSpawn())
                     this->gtinfo_->playerReadyToSpawn(it->first);
-            }
-                    
+                   
+                
+            }
             this->checkStart();
         }
@@ -143,4 +144,5 @@
     void Gametype::start()
     {
+         
         this->addBots(this->numberOfBots_);
 
@@ -148,4 +150,6 @@
 
         this->spawnPlayersIfRequested();
+        
+        
     }
 
@@ -376,5 +380,5 @@
                 {
                     this->gtinfo_->stopStartCountdown();
-                    this->gtinfo_->setStartCountdown(0.0f);;
+                    this->gtinfo_->setStartCountdown(0.0f);
                     this->start();
                 }
@@ -397,4 +401,5 @@
                             hashumanplayers = true;
                     }
+                         
                     if (allplayersready && hashumanplayers)
                     {
@@ -408,4 +413,5 @@
                 }
             }
+            
         }
     }
@@ -439,5 +445,5 @@
             if(player->isHumanPlayer())
                 this->gtinfo_->playerSpawned(player);
-            
+
             this->playerPostSpawn(player);
         }
Index: code/trunk/src/orxonox/gametypes/Gametype.h
===================================================================
--- code/trunk/src/orxonox/gametypes/Gametype.h	(revision 8952)
+++ code/trunk/src/orxonox/gametypes/Gametype.h	(revision 9016)
@@ -123,9 +123,6 @@
                 { return this->gtinfo_->getHUDTemplate(); }
 
-            void addBots(unsigned int amount);
+            virtual void addBots(unsigned int amount);
             void killBots(unsigned int amount = 0);
-
-            inline unsigned int getNumberOfPlayers() const
-                { return this->players_.size(); }
 
             virtual void addTime(float t);
@@ -151,8 +148,12 @@
 
             //inline bool getForceSpawn()
-            //  { return this->bForceSpawn_; }       
+            //  { return this->bForceSpawn_; }
 
             virtual void resetTimer();
             virtual void resetTimer(float t);
+            inline unsigned int getNumberOfPlayers()
+              { return this->gtinfo_->getNumberOfPlayers(); }
+
+	
 
         protected:
@@ -192,4 +193,5 @@
             ConsoleCommand* dedicatedKillBots_;
             /* HACK HACK HACK */
+
     };
 }
Index: code/trunk/src/orxonox/gametypes/Mission.cc
===================================================================
--- code/trunk/src/orxonox/gametypes/Mission.cc	(revision 9016)
+++ code/trunk/src/orxonox/gametypes/Mission.cc	(revision 9016)
@@ -0,0 +1,99 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Johannes Ritz
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "Mission.h"
+#include "items/Engine.h"
+#include "controllers/ArtificialController.h"
+
+#include "core/CoreIncludes.h"
+#include "network/Host.h"
+#include "worldentities/pawns/Pawn.h"
+
+namespace orxonox
+{
+    CreateUnloadableFactory(Mission);
+
+    Mission::Mission(BaseObject* creator) : TeamGametype(creator)
+    {
+        RegisterObject(Mission);
+        this->missionAccomplished_ = false;
+        this->lives_ = 10; // should be 1 as default value
+        this->numberOfBots_ = 0; //sets number of default bots temporarly to 0
+    }
+
+    void Mission::tick(float dt)
+    {
+        SUPER(Mission, tick, dt);
+
+        if (missionAccomplished_)
+        {
+            this->gtinfo_->sendAnnounceMessage("Mission accomplished!");
+            this->end();
+        }
+    }
+
+    void Mission::pawnKilled(Pawn* victim, Pawn* killer)
+    {
+        if (victim && victim->getPlayer() && this->lives_ == 1)
+        {
+            this->missionAccomplished_ = false;
+	    this->end();
+        }
+    }
+
+    void Mission::start()
+    {
+        Gametype::start();
+        this->setTeams();
+
+        this->gtinfo_->sendAnnounceMessage("Your mission has started!");
+    }
+
+    void Mission::end()
+    {
+        Gametype::end();
+	/*if (this->missionAccomplished_) 
+            this->gtinfo_->sendAnnounceMessage("Mission accomplished!");
+	else
+            this->gtinfo_->sendAnnounceMessage("Mission failed!");
+	 * */
+    }
+
+    void Mission::setTeams()
+    {//Set pawn-colours
+        for (ObjectList<Pawn>::iterator it = ObjectList<Pawn>::begin(); it != ObjectList<Pawn>::end(); ++it)
+        {
+            Pawn* pawn = static_cast<Pawn*>(*it);
+            if(!pawn) continue;
+                this->setDefaultObjectColour(pawn);
+        }
+    }
+
+
+
+}
Index: code/trunk/src/orxonox/gametypes/Mission.h
===================================================================
--- code/trunk/src/orxonox/gametypes/Mission.h	(revision 9016)
+++ code/trunk/src/orxonox/gametypes/Mission.h	(revision 9016)
@@ -0,0 +1,64 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Johannes Ritz
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _Mission_H__
+#define _Mission_H__
+
+#include "OrxonoxPrereqs.h"
+//#include "Gametype.h"
+#include "TeamGametype.h"
+
+namespace orxonox
+{
+    class _OrxonoxExport Mission : public TeamGametype
+    {
+        public:
+            Mission(BaseObject* creator);
+            virtual ~Mission() {}
+
+            virtual void tick(float dt);
+
+            virtual void start();
+            virtual void end();
+            virtual void setTeams();
+            virtual void addBots(unsigned int amount){} //<! overwrite function in order to bypass the addbots command
+            inline void setLives(unsigned int amount)
+                {this->lives_ = amount;}
+            inline unsigned int getLives()
+                {return this->lives_;}
+
+        protected:
+            virtual void pawnKilled(Pawn* victim, Pawn* killer = 0);
+            bool missionAccomplished_; //<! indicates if player successfully finsihed the mission;
+            int lives_; //<! amount of player's lives <-> nr. of retries
+
+    };
+}
+
+#endif /* _Mission_H__ */
+
